﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using System.Windows;
using System.Windows.Controls;

namespace SfColumns
{
    public class TestTextRenderer : GridVirtualizingCellRenderer<TextBlock, TestTextBox>
    {
        protected override TextBlock OnCreateDisplayUIElement()
        {
            return new TextBlock();
        }

        protected override TestTextBox OnCreateEditUIElement()
        {
            return new TestTextBox();
        }

        public override void OnInitializeEditElement(DataColumnBase dataColumn, TestTextBox uiElement, object dataContext)
        {
            base.OnInitializeEditElement(dataColumn, uiElement, dataContext);

            uiElement.SetBinding(TextBox.TextProperty, dataColumn.GridColumn.ValueBinding);

            VisualContainer.SetWantsMouseInput(uiElement, true);
            FocusManagerHelper.SetFocusedElement(uiElement, true);
        }

        protected override void OnEditElementLoaded(object sender, RoutedEventArgs e)
        {
            base.OnEditElementLoaded(sender, e);
            var customTextBox = (TestTextBox)sender;
            customTextBox.Focus();
        }
    }

    public class TestCheckBoxRenderer : GridCellCheckBoxRenderer
    {
        protected override CheckBox OnCreateEditUIElement()
        {
            return new TestCheckBox();
        }
    }
}
